{-| 
    Module      :  Main
    Description :  laucher for polynomial arith tests
    Copyright   :  (c) Michal Konecny
    License     :  BSD3

    Maintainer  :  mik@konecny.aow.cz
    Stability   :  experimental
    Portability :  portable

    An executable for easy automated launch of
    polynomial arithmetic tests.
-}
module Main where

import qualified Data.Number.ER.RnToRm.UnitDom.Base as UFB
import Data.Number.ER.RnToRm.UnitDom.Base.Tests.Run
import Data.Number.ER.RnToRm.DefaultRepr
import Data.Number.ER.Real.DefaultRepr

import Data.Number.ER.RnToRm.UnitDom.Base.Tests.Properties.Compose
import Data.Number.ER.RnToRm.UnitDom.Base.Tests.Properties.Common
import Data.Number.ER.RnToRm.UnitDom.Base.Tests.Generate
import Data.Number.ER.BasicTypes.Tests.Generate

main =
    do
    runUFBTests "cheb-poly-double" samplePBM (UFB.initialiseBaseArithmetic samplePBM)

samplePBM :: P BM
samplePBM = UFB.const 0

failed1 = 
    -- identified 24 Jul 19:00
     prop_enclCompose_ThinEncl_consistent (samplePBM,samplePBM) "a"
        (Deg10Size10 9 8, 7,
         FBEnclThinSize10 ((0,72),
            makeThinEncl (polynomials1200ishSize10Small samplePBM !! 72)),
         FBEnclThinSize10 ((0,853),
            makeThinEncl (polynomials1200ishSize10Small samplePBM !! 853))
        )

--failed1 = 
--    -- identified 24 Jul 15:00
--    -- fixed - error in enclMultiply 24 Jul 16:25
--     prop_enclScale_ParalEncl_consistent (samplePBM,samplePBM) "a"
--        (Deg10Size10 7 7, SmallRatio 220736 320174,
--         FBEnclParalSize10 (((0,872),SmallRatio (-50723) 723338),
--            makeParalEncl (polynomials1200ishSize10Small samplePBM !! 872) (SmallRatio (-50723) 723338))
--        )

